require_relative '../tunnel_blick'

module TunnelBlick

  module ExpressVPN

    class << self

      def parse_config (string)

        details = OpenStruct.new
        details.provider = 'ExpressVPN'

        string = string.sub('my_expressvpn_', '')
        string.sub!(/_\D{3}\z/, '')

        if string.split('_').size == 2
          details.country = string.sub('_', ' ').titlecase
          details.label = details.country
          return details
        else

        end

        country = string.split('-')[0]
        string.sub!(country, '')
        country.gsub!('_', ' ').strip!
        country = %w"usa".include?(country) ? country.upcase : country.titlecase
        details.country = country

        city = ['Hong Kong'].include?(country) ? country : string.split('-_')[1]
        string.gsub!(city, '')
        city = city.gsub('_', ' ').strip.titlecase.sub('Dc', 'DC')
        details.city = city

        label = country == city ? country : "#{country} - #{city}"
        number = string.scan(/\d/)
        label = label + " - #{number[0]}" unless number.empty?
        details.label = label

        details
      end

    end

  end

end