require_relative '../tunnel_blick'
require_relative 'tunnel'

module TunnelBlick

  class Tunnel

    def connect_same

      if @cycle_num == -1
        @cycle_num = 0
      end

      connect(@cycle_num)
    end

    def connect_cycle (reset = false)

      last_num = @shortlist.size - 1

      if reset
        @cycle_num = 0
      else
        @cycle_num += 1
      end

      if @cycle_num > last_num
        @cycle_num = 0
      end
      disconnect if connected?
      connect(@cycle_num)
    end

    def change_ip (allow_bare = false)
      start_ip = TunnelBlick.my_ip

      if connected?
        disconnect
        sleep(3)

        if allow_bare
          return TunnelBlick.my_ip
        end
      end

      new_ip = start_ip.dup
      until new_ip != start_ip
        disconnect
        new_ip = connect_cycle
      end
      new_ip
    end

    def change_ip_unique (reset = false)

      TunnelBlick.set_unique_attempts(6) if TunnelBlick.uniq_tries.nil?
      @checked_ips = [] if @checked_ips.nil? || reset
      my_ip = change_ip
      counter = 1

      while @checked_ips.include?(my_ip) && counter < TunnelBlick.uniq_tries
        my_ip = change_ip
        counter += 1
      end
      @checked_ips << my_ip

      if counter == TunnelBlick.uniq_tries
        sputs "unique ip change failed after #{counter} tries"
        false
      else
        my_ip
      end

    end

  end

end