require_relative '../tunnel_blick'

include Appscript

module TunnelBlick

  class Tunnel
    attr_accessor :tunnel

    def initialize
      @tunnel = Appscript.app('Tunnelblick.app')
      TunnelBlick.conn_sleep = 3.5 if TunnelBlick.conn_sleep.nil?
      shortlist_configs
    end

    def get_config_info (config)
      match_provider(config).parse_config(config)
    end

    def shortlist_configs
      if TunnelBlick.countries.nil?
        @shortlist = vpn_configs
      else
        @shortlist = vpn_configs.select { |config|
          details = get_config_info(config)
          TunnelBlick.countries.include?(details.country)
        }
      end
      @cycle_num = -1
    end

    def vpn_states; tunnel.configurations.state.get end

    def vpn_configs; tunnel.configurations.name.get end

    def connected?; vpn_states.include?('CONNECTED') end

    def current_config
      if connected?
        position = vpn_states.index('CONNECTED')
        vpn_configs[position]
      else
        nil
      end
    end

    def connect (num = nil, logging = true)

      if num.nil?
        target = @shortlist.sample
      else
        target = @shortlist[num]
      end

      TunnelBlick.ip_db.disconnect
      Sequel::Model.db.disconnect
      print '*'

      tunnel.connect(target)
      until connected?
        sleep(1)
        print '.'
      end
      puts '$'
      sleep(TunnelBlick.conn_sleep)

      details = get_config_info(target)
      TunnelBlick.details = details
      my_ip = TunnelBlick.my_ip

      if logging

        info = details.dup
        info.public_ip = my_ip

        test_okay = false
        until test_okay
          sleep(3)
          conn1_okay = TunnelBlick.ip_db.test_connection
          sleep(1)
          conn2_okay = Sequel::Model.db.test_connection
          print '.'
          test_okay = conn1_okay && conn2_okay
        end
        puts '$'
        # Sequel::Model.db = TunnelBlick.ip_db
        TunnelBlick.try_log_info(info)
      end

      my_ip
    end

    def disconnect; tunnel.disconnect_all if connected? end

    def match_provider (config_name)

      case config_name
        when /\Amy_expressvpn.+/
          TunnelBlick::ExpressVPN
        else
          raise ArgumentError('VPN provider not recognized.')
      end

    end

  end

end